#include "LSYzController.h"

const char szVersion[] = "LSYzController 1.0.2 (Whitman)";
const char szAppName[] = "LSYzController";

HINSTANCE hInstance;
HWND hwndMain, hwndParent;
YzConfig config;

int msgs[] =
{
    LM_GETREVID,
    LM_REFRESH,
    0
};

int initModuleEx(HWND hParent, HINSTANCE hInst, LPCSTR pszPath)
{
	hwndParent = hParent;
	hInstance = hInst;

    WNDCLASS wc = { 0 };
    wc.lpfnWndProc = WndProc;
	wc.hInstance = hInst;
	wc.lpszClassName = szAppName;
	
	RegisterClass(&wc);

	hwndMain = CreateWindowEx(WS_EX_TOOLWINDOW, szAppName, NULL, WS_POPUP, 0, 0, 0, 0, NULL, NULL, hInst, NULL);
	SendMessage(hwndParent, LM_REGISTERMESSAGE, (WPARAM)hwndMain, (LPARAM)msgs);

	AddBangCommand("!YzDockStart", startYzDockBang);
	AddBangCommand("!YzDockKill", killYzDockBang);
	AddBangCommand("!YzDockSaveConfig", saveConfigFile);
	AddBangCommand("!YzDockLoadConfig", readConfigFile);
	AddBangCommand("!YzDockUnloadModule", unloadModuleBang);
	AddBangCommand("!YzDockUseThemeConfig", useThemeConfigBang);
	AddBangCommand("!YzDockToggle", toggleBang);

	config = YzConfig();
	startUp();

	return 0;
}

void quitModule(HINSTANCE hInst)
{
	SendMessage(hwndParent, LM_UNREGISTERMESSAGE, (WPARAM)hwndMain, (LPARAM)msgs);

    DestroyWindow(hwndMain);
	UnregisterClass(szAppName, hInst);

	RemoveBangCommand("!YzDockStart");
	RemoveBangCommand("!YzDockKill");
	RemoveBangCommand("!YzDockSaveConfig");
	RemoveBangCommand("!YzDockLoadConfig");
	RemoveBangCommand("!YzDockUnloadModule");
	RemoveBangCommand("!YzDockUseThemeConfig");
	RemoveBangCommand("!YzDockToggle");
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	switch (msg) {
		case LM_GETREVID: {
			if (wParam == 0 || wParam == 1) {
				LPSTR buf = (LPSTR)lParam;
				strcpy(buf, szVersion);
                return strlen(buf);
            }
			return 0;
		}
		break;

        case LM_REFRESH: {
			getRCConfigVars();
        }
        break;
	}
	return DefWindowProc(hwnd, msg, wParam, lParam);
}

void startUp() {
	char szTempBuf[256];
	BOOL stringFound = FALSE;
	stringFound = GetRCString("YzDockDirectory", szTempBuf, "", 256);
	if (stringFound) {
		char szTempExePath[256];
		strcpy(szTempExePath, szTempBuf);
		strcat(szTempExePath, "YzDock.exe");
		if (PathFileExists(szTempExePath)) {
			config.setYzDockDirectory(szTempBuf);

			stringFound = FALSE;
			stringFound = GetRCString("*YzDockKill", szTempBuf ,"", 256);
			if (stringFound) {
				killYzDock();
			}

			stringFound = FALSE;
			stringFound = GetRCString("*YzDockUseThemeConfig", szTempBuf, "", 256);
			if (stringFound) {
				useThemeConfig();
			}

			stringFound = FALSE;
			stringFound = GetRCString("*YzDockLoadConfig", szTempBuf, "", 256);
			if (stringFound) {
				config.readConfigFile();
			}

			getRCConfigVars();

			stringFound = FALSE;
			stringFound = GetRCString("*YzDockSaveConfig", szTempBuf, "", 256);
			if (stringFound) {
				config.writeConfigFile();
			}

			stringFound = FALSE;
			stringFound = GetRCString("*YzDockStart", szTempBuf ,"", 256);
			if (stringFound) {
				startYzDock();
			}

			stringFound = FALSE;
			stringFound = GetRCString("*YzDockRestart", szTempBuf ,"", 256);
			if (stringFound) {
				killYzDock();
				startYzDock();
			}

			stringFound = FALSE;
			stringFound = GetRCString("*YzDockUnloadModuleOnLoad", szTempBuf, "", 256);
			if (stringFound) {
				unloadModule();
			}
		}
		else {
			unloadModule();
		}
	}
	else {
		unloadModule();
	}
}

void unloadModuleBang(HWND hCaller, LPCSTR pszArgs) {
	unloadModule();
}

void unloadModule() {
	PostMessage(hwndParent, LM_UNLOADMODULE, (WPARAM)hInstance, LMM_HINSTANCE);
}

void useThemeConfigBang(HWND hCaller, LPCSTR pszArgs) {
	useThemeConfig();
}

void useThemeConfig() {
	char szYzDockThemePath[256];
	char szTempBuf[256];
	char szExistingFile[256];
	GetRCString("ThemesDir", szYzDockThemePath, "", 256);
	GetRCString("ThemeName", szTempBuf, "", 256);
	strcat(szYzDockThemePath, szTempBuf);
	strcat(szYzDockThemePath, "\\misc\\YzDock\\");
	strcpy(szExistingFile, szYzDockThemePath);
	strcat(szExistingFile, "YzDock.ini");

	if (PathFileExists(szExistingFile)) {
		char szNewFile[256];
		strcpy(szExistingFile, config.getYzDockDirectory());
		strcat(szExistingFile, "YzDock.ini");
		strcpy(szNewFile, config.getYzDockDirectory());
		strcat(szNewFile, "YzDock.ini.bak");
		CopyFile(szExistingFile, szNewFile, false);

		GetRCString("ThemesDir", szYzDockThemePath, "", 256);
		GetRCString("ThemeName", szTempBuf, "", 256);
		strcat(szYzDockThemePath, szTempBuf);
		strcat(szYzDockThemePath, "\\misc\\YzDock\\");
		strcpy(szExistingFile, szYzDockThemePath);
		strcat(szExistingFile, "YzDock.ini");
		strcpy(szNewFile, config.getYzDockDirectory());
		strcat(szNewFile, "YzDock.ini");
		CopyFile(szExistingFile, szNewFile, false);
	}
}

void startYzDockBang(HWND hCaller, LPCSTR pszArgs) {
	startYzDock();
}

void startYzDock() {
	char *YzDockDirectory = config.getYzDockDirectory();
	char YzDockExePath[256];
	strcpy(YzDockExePath, YzDockDirectory);
	strcat(YzDockExePath, "YzDock.exe");
	ShellExecute(NULL, NULL, YzDockExePath, "", "", SW_SHOW);
}

void killYzDockBang(HWND hCaller, LPCSTR pszArgs) {
	killYzDock();
}

void killYzDock() {
	HWND hWnd = FindWindow("YzDockClass", "Y'z Dock");
	if (hWnd != NULL) {
		SendMessage(hWnd, WM_CLOSE, NULL, NULL);
	}
}

void toggleBang(HWND hCaller, LPCSTR pszArgs) {
	toggleDock();
}

void toggleDock() {
	HWND hWnd = FindWindow("YzDockClass", "Y'z Dock");
	if (hWnd == NULL) {
		startYzDock();
	}
	else {
		killYzDock();
	}
}

void saveConfigFile(HWND hCaller, LPCSTR pszArgs) {
	config.writeConfigFile();
}

void readConfigFile(HWND hCaller, LPCSTR pszArgs) {
	config.readConfigFile();
}

void getRCConfigVars() {
	char szTempBuf[256];
	char szDefaultValue[256];
	int iDefaultValue;
	BOOL bDefaultValue;
	BOOL bTempBool;
	COLORREF crDefaultValue;

	// Get YzDock Language File
	if (config.configIsLoaded()) {
		strcpy(szDefaultValue, config.getLanguageFile());
	}
	else {
		strcpy(szDefaultValue, "English.lang");
	}
	GetRCString("YzDockLanguageFile", szTempBuf, szDefaultValue, 256);
	config.setLanguageFile(szTempBuf);

	// Get YzDock Small Size
	if (config.configIsLoaded()) {
		iDefaultValue = config.getSmallSize();
	}
	else {
		iDefaultValue = 48;
	}
	config.setSmallSize(GetRCInt("YzDockSmallSize", iDefaultValue));

	// Get YzDock Large Size
	if (config.configIsLoaded()) {
		iDefaultValue = config.getLargeSize();
	}
	else {
		iDefaultValue = 128;
	}
	config.setLargeSize(GetRCInt("YzDockLargeSize", iDefaultValue));

	// Get YzDock Magnification
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getMagnification();
	}
	else {
		bDefaultValue = TRUE;
	}
	bTempBool = GetRCBoolDef("YzDockMagnification", bDefaultValue);
	if (bTempBool) {
		config.setMagnification(1);
	}
	else {
		config.setMagnification(0);
	}

	// Get YzDock Indicator
	if (config.configIsLoaded()) {
		strcpy(szDefaultValue, config.getIndicator());
	}
	else {
		strcpy(szDefaultValue, "Default");
	}
	GetRCString("YzDockIndicator", szTempBuf, szDefaultValue, 256);
	config.setIndicator(szTempBuf);
	
	// Get YzDock Poof
	if (config.configIsLoaded()) {
		strcpy(szDefaultValue, config.getPoof());
	}
	else {
		strcpy(szDefaultValue, "Default");
	}
	GetRCString("YzDockPoof", szTempBuf, szDefaultValue, 256);
	config.setPoof(szTempBuf);

	// Get YzDock Background Alpha
	if (config.configIsLoaded()) {
		iDefaultValue = config.getBackgroundAlpha();
	}
	else {
		iDefaultValue = 180;
	}
	config.setBackgroundAlpha(GetRCInt("YzDockBackgroundAlpha", iDefaultValue));

	// Get YzDock Background Name
	if (config.configIsLoaded()) {
		strcpy(szDefaultValue, config.getBackgroundName());
	}
	else {
		strcpy(szDefaultValue, "Default");
	}
	GetRCString("YzDockBackgroundName", szTempBuf, szDefaultValue, 256);
	config.setBackgroundName(szTempBuf);

	// Get YzDock Always On Top
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getAlwaysOnTop();
	}
	else {
		bDefaultValue = TRUE;
	}
	bTempBool = GetRCBoolDef("YzDockAlwaysOnTop", bDefaultValue);
	if (bTempBool) {
		config.setAlwaysOnTop(1);
	}
	else {
		config.setAlwaysOnTop(0);
	}

	// Get YzDock Auto Hide
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getAutoHide();
	}
	else {
		bDefaultValue = TRUE;
	}
	bTempBool = GetRCBoolDef("YzDockAutoHide", bDefaultValue);
	if (bTempBool) {
		config.setAutoHide(1);
	}
	else {
		config.setAutoHide(0);
	}

	// Get YzDock Show Sensitivity
	if (config.configIsLoaded()) {
		iDefaultValue = config.getShowSensitivity();
	}
	else {
		iDefaultValue = 0;
	}
	config.setShowSensitivity(GetRCInt("YzDockShowSensitivity", iDefaultValue));

	// Get YzDock Disappear Delay Time
	if (config.configIsLoaded()) {
		iDefaultValue = config.getDisappearDelayTime();
	}
	else {
		iDefaultValue = 0;
	}
	config.setDisappearDelayTime(GetRCInt("YzDockDisappearDelayTime", iDefaultValue));

	// Get YzDock Open App Effect
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getOpenAppEffect();
	}
	else {
		bDefaultValue = TRUE;
	}
	bTempBool = GetRCBoolDef("YzDockOpenAppEffect", bDefaultValue);
	if (bTempBool) {
		config.setOpenAppEffect(1);
	}
	else {
		config.setOpenAppEffect(0);
	}

	// Get YzDock Open App Effect Except App
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getOpenAppEffectExceptApp();
	}
	else {
		bDefaultValue = 0;
	}
	bTempBool = GetRCBoolDef("YzDockOpenAppEffectExceptApp", bDefaultValue);
	if (bTempBool) {
		config.setOpenAppEffectExceptApp(1);
	}
	else {
		config.setOpenAppEffectExceptApp(0);
	}

	// Get YzDock Color Of Clicked Item
	if (config.configIsLoaded()) {
		iDefaultValue = config.getColorOfClickedItem();
	}
	else {
		iDefaultValue = 8355711;
	}
	crDefaultValue = (COLORREF)iDefaultValue;
	config.setColorOfClickedItem((int)GetRCColor("YzDockColorOfClickedItem", crDefaultValue));

	// Get YzDock Number Of Open App Effect
	if (config.configIsLoaded()) {
		iDefaultValue = config.getNumberOfOpenAppEffect();
	}
	else {
		iDefaultValue = 2;
	}
	config.setNumberOfOpenAppEffect(GetRCInt("YzDockNumberOfOpenAppEffect", iDefaultValue));

	// Get YzDock Locked Move Delete Item
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getLockedMoveDeleteItem();
	}
	else {
		bDefaultValue = FALSE;
	}
	bTempBool = GetRCBoolDef("YzDockLockedMoveDeleteItem", bDefaultValue);
	if (bTempBool) {
		config.setLockedMoveDeleteItem(1);
	}
	else {
		config.setLockedMoveDeleteItem(0);
	}

	// Get YzDock Window Focus Back
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getWindowFocusBack();
	}
	else {
		bDefaultValue = FALSE;
	}
	bTempBool = GetRCBoolDef("YzDockWindowFocusBack", bDefaultValue);
	if (bTempBool) {
		config.setWindowFocusBack(1);
	}
	else {
		config.setWindowFocusBack(0);
	}

	// Get YzDock Position On Screen
	if (config.configIsLoaded()) {
		iDefaultValue = config.getPositionOnScreen();
	}
	else {
		iDefaultValue = 0;
	}
	if (iDefaultValue == 0) {
		strcpy(szDefaultValue, "bottom");
	}
	else if (iDefaultValue == 1) {
		strcpy(szDefaultValue, "left");
	}
	else if (iDefaultValue == 2) {
		strcpy(szDefaultValue, "right");
	}
	else {
		strcpy(szDefaultValue, "top");
	}
	GetRCString("YzDockPositionOnScreen", szTempBuf, szDefaultValue, 256);
	if (stricmp(szTempBuf, "bottom") == 0) {
		config.setPositionOnScreen(0);
	}
	else if (stricmp(szTempBuf, "left") == 0) {
		config.setPositionOnScreen(1);
	}
	else if (stricmp(szTempBuf, "right") == 0) {
		config.setPositionOnScreen(2);
	}
	else if (stricmp(szTempBuf, "top") == 0) {
		config.setPositionOnScreen(3);
	}

	// Get YzDock Position On Screen 2
	if (config.configIsLoaded()) {
		iDefaultValue = config.getPositionOnScreen2();
	}
	else {
		iDefaultValue = 0;
	}
	if (iDefaultValue == 0) {
		strcpy(szDefaultValue, "center");
	}
	else if (iDefaultValue == 1) {
		strcpy(szDefaultValue, "left");
	}
	else {
		strcpy(szDefaultValue, "right");
	}
	GetRCString("YzDockPositionOnScreen2", szTempBuf, szDefaultValue, 256);
	if (stricmp(szTempBuf, "center") == 0) {
		config.setPositionOnScreen2(0);
	}
	else if (stricmp(szTempBuf, "bottom") == 0) {
		config.setPositionOnScreen2(2);
	}
	else if (stricmp(szTempBuf, "left") == 0) {
		config.setPositionOnScreen2(1);
	}
	else if (stricmp(szTempBuf, "right") == 0) {
		config.setPositionOnScreen2(2);
	}
	else if (stricmp(szTempBuf, "top") == 0) {
		config.setPositionOnScreen2(1);
	}

	// Get YzDock Position Margin
	if (config.configIsLoaded()) {
		iDefaultValue = config.getPositionMargin();
	}
	else {
		iDefaultValue = 0;
	}
	config.setPositionMargin(GetRCInt("YzDockPositionMargin", iDefaultValue));

	// Get YzDock Multi Monitor Support
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getMultiMonitorSupport();
	}
	else {
		bDefaultValue = FALSE;
	}
	bTempBool = GetRCBoolDef("YzDockMultiMonitorSupport", bDefaultValue);
	if (bTempBool) {
		config.setMultiMonitorSupport(1);
	}
	else {
		config.setMultiMonitorSupport(0);
	}

	// Get YzDock Font
	if (config.configIsLoaded()) {
		strcpy(szDefaultValue, config.getFont());
	}
	else {
		strcpy(szDefaultValue, "Tahoma");
	}
	GetRCString("YzDockFont", szTempBuf, szDefaultValue, 256);
	config.setFont(szTempBuf);

	// Get YzDock Font Size
	if (config.configIsLoaded()) {
		iDefaultValue = config.getFontSize();
	}
	else {
		iDefaultValue = 13;
	}
	config.setFontSize(GetRCInt("YzDockFontSize", iDefaultValue));

	// Get YzDock Bold
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getBold();
	}
	else {
		bDefaultValue = TRUE;
	}
	bTempBool = GetRCBoolDef("YzDockBold", bDefaultValue);
	if (bTempBool) {
		config.setBold(1);
	}
	else {
		config.setBold(0);
	}

	// Get YzDock Italic
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getItalic();
	}
	else {
		bDefaultValue = FALSE;
	}
	bTempBool = GetRCBoolDef("YzDockItalic", bDefaultValue);
	if (bTempBool) {
		config.setItalic(1);
	}
	else {
		config.setItalic(0);
	}

	// Get YzDock Direction Of Gradation
	if (config.configIsLoaded()) {
		iDefaultValue = config.getDirectionOfGradation();
	}
	else {
		iDefaultValue = 0;
	}
	if (iDefaultValue == 0) {
		strcpy(szDefaultValue, "none");
	}
	else if (iDefaultValue == 1) {
		strcpy(szDefaultValue, "vertical");
	}
	else {
		strcpy(szDefaultValue, "horizontal");
	}
	GetRCString("YzDockDirectionOfGradation", szTempBuf, szDefaultValue, 256);
	if (stricmp(szTempBuf, "none") == 0) {
		config.setDirectionOfGradation(0);
	}
	else if (stricmp(szTempBuf, "vertical") == 0) {
		config.setDirectionOfGradation(1);
	}
	else if (stricmp(szTempBuf, "horizontal") == 0) {
		config.setDirectionOfGradation(2);
	}

	// Get YzDock Color
	if (config.configIsLoaded()) {
		iDefaultValue = config.getColor();
	}
	else {
		iDefaultValue = 16777215;
	}
	crDefaultValue = (COLORREF)iDefaultValue;
	config.setColor((int)GetRCColor("YzDockColor", crDefaultValue));


	// Get YzDock Color 2
	if (config.configIsLoaded()) {
		iDefaultValue = config.getColor2();
	}
	else {
		iDefaultValue = 16697014;
	}
	crDefaultValue = (COLORREF)iDefaultValue;
	config.setColor2((int)GetRCColor("YzDockColor2", crDefaultValue));

	// Get YzDock Edge Color
	if (config.configIsLoaded()) {
		iDefaultValue = config.getEdgeColor();
	}
	else {
		iDefaultValue = 0;
	}
	crDefaultValue = (COLORREF)iDefaultValue;
	config.setEdgeColor((int)GetRCColor("YzDockEdgeColor", crDefaultValue));

	// Get YzDock Edge Color 2
	if (config.configIsLoaded()) {
		iDefaultValue = config.getEdgeColor2();
	}
	else {
		iDefaultValue = 16711680;
	}
	crDefaultValue = (COLORREF)iDefaultValue;
	config.setEdgeColor2((int)GetRCColor("YzDockEdgeColor2", crDefaultValue));

	// Get YzDock Shadow Color
	if (config.configIsLoaded()) {
		iDefaultValue = config.getShadowColor();
	}
	else {
		iDefaultValue = 0;
	}
	crDefaultValue = (COLORREF)iDefaultValue;
	config.setShadowColor((int)GetRCColor("YzDockShadowColor", crDefaultValue));

	// Get Yz Dock Shadow Color 2
	if (config.configIsLoaded()) {
		iDefaultValue = config.getShadowColor2();
	}
	else {
		iDefaultValue = 5395026;
	}
	crDefaultValue = (COLORREF)iDefaultValue;
	config.setShadowColor2((int)GetRCColor("YzDockShadowColor2", crDefaultValue));

	// Get YzDock Edge Alpha
	if (config.configIsLoaded()) {
		iDefaultValue = config.getEdgeAlpha();
	}
	else {
		iDefaultValue = 50;
	}
	config.setEdgeAlpha(GetRCInt("YzDockEdgeAlpha", iDefaultValue));

	// Get YzDock Shadow Alpha
	if (config.configIsLoaded()) {
		iDefaultValue = config.getShadowAlpha();
	}
	else {
		iDefaultValue = 180;
	}
	config.setShadowAlpha(GetRCInt("YzDockShadowAlpha", iDefaultValue));

	// Get YzDock Fade Effect When Mouse Move
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getFadeEffectWhenMouseMove();
	}
	else {
		bDefaultValue = FALSE;
	}
	bTempBool = GetRCBoolDef("YzDockFadeEffectWhenMouseMove", bDefaultValue);
	if (bTempBool) {
		config.setFadeEffectWhenMouseMove(1);
	}
	else {
		config.setFadeEffectWhenMouseMove(0);
	}

	// Get YzDock Icon Size
	if (config.configIsLoaded()) {
		iDefaultValue = config.getIconSize();
	}
	else {
		iDefaultValue = 1;
	}
	if (iDefaultValue == 1) {
		strcpy(szDefaultValue, "small");
	}
	else if (iDefaultValue == 2) {
		strcpy(szDefaultValue, "large");
	}
	else {
		strcpy(szDefaultValue, "dynamic");
	}
	GetRCString("YzDockIconSize", szTempBuf, szDefaultValue, 256);
	if (stricmp(szTempBuf, "small") == 0) {
		config.setIconSize(1);
	}
	else if (stricmp(szTempBuf, "large") == 0) {
		config.setIconSize(2);
	}
	else if (stricmp(szTempBuf, "dynamic") == 0) {
		config.setIconSize(3);
	}

	// Get YzDock Show Mode File Extension
	if (config.configIsLoaded()) {
		iDefaultValue = config.getShowModeFileExtension();
	}
	else {
		iDefaultValue = 1;
	}
	if (iDefaultValue == 0) {
		strcpy(szDefaultValue, "hide");
	}
	else if (iDefaultValue == 1) {
		strcpy(szDefaultValue, "show");
	}
	else {
		strcpy(szDefaultValue, "hideregistered");
	}
	GetRCString("YzDockShowModeFileExtension", szTempBuf, szDefaultValue, 256);
	if (stricmp(szTempBuf, "hide") == 0) {
		config.setShowModeFileExtension(0);
	}
	else if (stricmp(szTempBuf, "show") == 0) {
		config.setShowModeFileExtension(1);
	}
	else if (stricmp(szTempBuf, "hideregistered") == 0) {
		config.setShowModeFileExtension(2);
	}

	// Get YzDock Show Open Folder Item
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getShowOpenFolderItem();
	}
	else {
		bDefaultValue = FALSE;
	}
	bTempBool = GetRCBoolDef("YzDockShowOpenFolderItem", bDefaultValue);
	if (bTempBool) {
		config.setShowOpenFolderItem(1);
	}
	else {
		config.setShowOpenFolderItem(0);
	}

	// Get YzDock Open Folder Item Label
	if (config.configIsLoaded()) {
		strcpy(szDefaultValue, config.getOpenFolderItemLabel());
	}
	else {
		strcpy(szDefaultValue, "Show in Explorer");
	}
	GetRCString("YzDockOpenFolderItemLabel", szTempBuf, szDefaultValue, 256);
	config.setOpenFolderItemLabel(szTempBuf);

	// Get YzDock Removable Drive Has Sub Menu
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getRemovableDriveHasSubMenu();
	}
	else {
		bDefaultValue = TRUE;
	}
	bTempBool = GetRCBoolDef("YzDockRemovableDriveHasSubMenu", bDefaultValue);
	if (bTempBool) {
		config.setRemovableDriveHasSubMenu(1);
	}
	else {
		config.setRemovableDriveHasSubMenu(0);
	}

	// Get YzDock Shortcut Folder Has Sub Menu
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getShortcutFolderHasSubMenu();
	}
	else {
		bDefaultValue = TRUE;
	}
	bTempBool = GetRCBoolDef("YzDockShortcutFolderHasSubMenu", bDefaultValue);
	if (bTempBool) {
		config.setShortcutFolderHasSubMenu(1);
	}
	else {
		config.setShortcutFolderHasSubMenu(0);
	}

	// Get YzDock Low Quality In Hovering
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getLowQualityInHovering();
	}
	else {
		bDefaultValue = FALSE;
	}
	bTempBool = GetRCBoolDef("YzDockLowQualityInHovering", bDefaultValue);
	if (bTempBool) {
		config.setLowQualityInHovering(1);
	}
	else {
		config.setLowQualityInHovering(0);
	}

	// Get YzDock Low Quality In Magnification
	if (config.configIsLoaded()) {
		bDefaultValue = (BOOL)config.getLowQualityInMagnification();
	}
	else {
		bDefaultValue = FALSE;
	}
	bTempBool = GetRCBoolDef("YzDockLowQualityInMagnification", bDefaultValue);
	if (bTempBool) {
		config.setLowQualityInMagnification(1);
	}
	else {
		config.setLowQualityInMagnification(0);
	}

	// Get YzDock Magnification Mode
	if (config.configIsLoaded()) {
		iDefaultValue = config.getMagnificationMode();
	}
	else {
		iDefaultValue = 1;
	}
	if (iDefaultValue == 0) {
		strcpy(szDefaultValue, "narrow");
	}
	else {
		strcpy(szDefaultValue, "wide");
	}
	GetRCString("YzDockMagnificationMode", szTempBuf, szDefaultValue, 256);
	if (stricmp(szTempBuf, "narrow") == 0) {
		config.setMagnificationMode(0);
	}
	else if (stricmp(szTempBuf, "wide") == 0) {
		config.setMagnificationMode(1);
	}

	// Get YzDock Transition Smoothness Expand
	if (config.configIsLoaded()) {
		iDefaultValue = config.getTransitionSmoothnessExpand();
	}
	else {
		iDefaultValue = 35;
	}
	config.setTransitionSmoothnessExpand(GetRCInt("YzDockTransitionSmoothnessExpand", iDefaultValue));

	// Get YzDock Transition Smoothness Reduce
	if (config.configIsLoaded()) {
		iDefaultValue = config.getTransitionSmoothnessReduce();
	}
	else {
		iDefaultValue = 35;
	}
	config.setTransitionSmoothnessReduce(GetRCInt("YzDockTransitionSmoothnessReduce", iDefaultValue));
}