#include "YzConfig.h"
#include <stdio.h>

void YzConfig::writeConfigFile() {
	if (strcmp(YzDockDirectory, ".none") != 0) {
		char YzDockConfigIniPath[256];
		strcpy(YzDockConfigIniPath, YzDockDirectory);
		strcat(YzDockConfigIniPath, "YzDock.ini");
		FILE *filePointer;
		if (!(filePointer = fopen(YzDockConfigIniPath, "w"))) {
			return;
		}
		fprintf(filePointer, "[General]\n");
		fprintf(filePointer, "LanguageFile=%s\n", LanguageFile);
		fprintf(filePointer, "[Appearance]\n");
		fprintf(filePointer, "SmallSize=%d\n", SmallSize);
		fprintf(filePointer, "LargeSize=%d\n", LargeSize);
		fprintf(filePointer, "Magnification=%d\n", Magnification);
		fprintf(filePointer, "Indicator=%s\n", Indicator);
		fprintf(filePointer, "Poof=%s\n", Poof);
		fprintf(filePointer, "BackgroundAlpha=%d\n", BackgroundAlpha);
		fprintf(filePointer, "BackgroundName=%s\n", BackgroundName);
		fprintf(filePointer, "[Behavior]\n");
		fprintf(filePointer, "AlwaysOnTop=%d\n", AlwaysOnTop);
		fprintf(filePointer, "AutoHide=%d\n", AutoHide);
		fprintf(filePointer, "ShowSensitivity=%d\n", ShowSensitivity);
		fprintf(filePointer, "DisappearDelayTime=%d\n", DisappearDelayTime);
		fprintf(filePointer, "OpenAppEffect=%d\n", OpenAppEffect);
		fprintf(filePointer, "OpenAppEffectExceptApp=%d\n", OpenAppEffectExceptApp);
		fprintf(filePointer, "ColorOfClickedItem=%d\n", ColorOfClickedItem);
		fprintf(filePointer, "NumberOfOpenAppEffect=%d\n", NumberOfOpenAppEffect);
		fprintf(filePointer, "LockedMoveDeleteItem=%d\n", LockedMoveDeleteItem);
		fprintf(filePointer, "WindowFocusBack=%d\n", WindowFocusBack);
		fprintf(filePointer, "[Position]\n");
		fprintf(filePointer, "PositionOnScreen=%d\n", PositionOnScreen);
		fprintf(filePointer, "PositionOnScreen2=%d\n", PositionOnScreen2);
		fprintf(filePointer, "PositionMargin=%d\n", PositionMargin);
		fprintf(filePointer, "MultiMonitorSupport=%d\n", MultiMonitorSupport);
		fprintf(filePointer, "[ItemLabel]\n");
		fprintf(filePointer, "Font=%s\n", Font);
		fprintf(filePointer, "FontSize=%d\n", FontSize);
		fprintf(filePointer, "Bold=%d\n", Bold);
		fprintf(filePointer, "Italic=%d\n", Italic);
		fprintf(filePointer, "DirectionOfGradation=%d\n", DirectionOfGradation);
		fprintf(filePointer, "Color=%d\n", Color);
		fprintf(filePointer, "Color2=%d\n", Color2);
		fprintf(filePointer, "EdgeColor=%d\n", EdgeColor);
		fprintf(filePointer, "EdgeColor2=%d\n", EdgeColor2);
		fprintf(filePointer, "ShadowColor=%d\n", ShadowColor);
		fprintf(filePointer, "ShadowColor2=%d\n", ShadowColor2);
		fprintf(filePointer, "EdgeAlpha=%d\n", EdgeAlpha);
		fprintf(filePointer, "ShadowAlpha=%d\n", ShadowAlpha);
		fprintf(filePointer, "FadeEffectWhenMouseMove=%d\n", FadeEffectWhenMouseMove);
		fprintf(filePointer, "[Menu]\n");
		fprintf(filePointer, "IconSize=%d\n", IconSize);
		fprintf(filePointer, "ShowModeFileExtension=%d\n", ShowModeFileExtension);
		fprintf(filePointer, "ShowOpenFolderItem=%d\n", ShowOpenFolderItem);
		fprintf(filePointer, "OpenFolderItemLabel=%s\n", OpenFolderItemLabel);
		fprintf(filePointer, "RemovableDriveHasSubMenu=%d\n", RemovableDriveHasSubMenu);
		fprintf(filePointer, "ShortcutFolderHasSubMenu=%d\n", ShortcutFolderHasSubMenu);
		fprintf(filePointer, "[Performance]\n");
		fprintf(filePointer, "LowQualityInHovering=%d\n", LowQualityInHovering);
		fprintf(filePointer, "LowQualityInMagnification=%d\n", LowQualityInMagnification);
		fprintf(filePointer, "MagnificationMode=%d\n", MagnificationMode);
		fprintf(filePointer, "TransitionSmoothnessExpand=%d\n", TransitionSmoothnessExpand);
		fprintf(filePointer, "TransitionSmoothnessReduce=%d\n", TransitionSmoothnessReduce);
		fclose(filePointer);
	}
	return;
}

void YzConfig::readConfigFile() {
	if (strcmp(YzDockDirectory, ".none") != 0) {
		char YzDockConfigIniPath[256];
		strcpy(YzDockConfigIniPath, YzDockDirectory);
		strcat(YzDockConfigIniPath, "YzDock.ini");
		FILE *filePointer;
		char line[256];
		if (!(filePointer = fopen(YzDockConfigIniPath, "r"))) {
			return;
		}
		while (!feof(filePointer)) {
			if (fgets(line,sizeof(line), filePointer) != NULL) {
				char *tmp;
				tmp = strchr(line, '\n');
				if (tmp != NULL) {
					*tmp = '\0';
				}
				char seps[] = "=";
				char* szVar = strtok(line, seps);
				char* szValue = strtok(NULL, seps);
				if (strcmp(szVar, "LanguageFile") == 0) {
					strcpy(LanguageFile, szValue);
				}
				else if (strcmp(szVar, "SmallSize") == 0) {
					SmallSize = atoi(szValue);
				}
				else if (strcmp(szVar, "LargeSize") == 0) {
					LargeSize = atoi(szValue);
				}
				else if (strcmp(szVar, "Magnification") == 0) {
					Magnification = atoi(szValue);
				}
				else if (strcmp(szVar, "Indicator") == 0) {
					strcpy(Indicator, szValue);
				}
				else if (strcmp(szVar, "Poof") == 0) {
					strcpy(Poof, szValue);
				}
				else if (strcmp(szVar, "BackgroundAlpha") == 0) {
					BackgroundAlpha = atoi(szValue);
				}
				else if (strcmp(szVar, "BackgroundName") == 0) {
					strcpy(BackgroundName, szValue);
				}
				else if (strcmp(szVar, "AlwaysOnTop") == 0) {
					AlwaysOnTop = atoi(szValue);
				}
				else if (strcmp(szVar, "AutoHide") == 0) {
					AutoHide = atoi(szValue);
				}
				else if (strcmp(szVar, "ShowSensitivity") == 0) {
					ShowSensitivity = atoi(szValue);
				}
				else if (strcmp(szVar, "DisappearDelayTime") == 0) {
					DisappearDelayTime = atoi(szValue);
				}
				else if (strcmp(szVar, "OpenAppEffect") == 0) {
					OpenAppEffect = atoi(szValue);
				}
				else if (strcmp(szVar, "OpenAppEffectExceptApp") == 0) {
					OpenAppEffectExceptApp = atoi(szValue);
				}
				else if (strcmp(szVar, "ColorOfClickedItem") == 0) {
					ColorOfClickedItem = atoi(szValue);
				}
				else if (strcmp(szVar, "NumberOfOpenAppEffect") == 0) {
					NumberOfOpenAppEffect = atoi(szValue);
				}
				else if (strcmp(szVar, "LockedMoveDeleteItem") == 0) {
					LockedMoveDeleteItem = atoi(szValue);
				}
				else if (strcmp(szVar, "WindowFocusBack") == 0) {
					WindowFocusBack = atoi(szValue);
				}
				else if (strcmp(szVar, "PositionOnScreen") == 0) {
					PositionOnScreen = atoi(szValue);
				}
				else if (strcmp(szVar, "PositionOnScreen2") == 0) {
					PositionOnScreen2 = atoi(szValue);
				}
				else if (strcmp(szVar, "PositionMargin") == 0) {
					PositionMargin = atoi(szValue);
				}
				else if (strcmp(szVar, "MultiMonitorSupport") == 0) {
					MultiMonitorSupport = atoi(szValue);
				}
				else if (strcmp(szVar, "Font") == 0) {
					strcpy(Font, szValue);
				}
				else if (strcmp(szVar, "FontSize") == 0) {
					FontSize = atoi(szValue);
				}
				else if (strcmp(szVar, "Bold") == 0) {
					Bold = atoi(szValue);
				}
				else if (strcmp(szVar, "Italic") == 0) {
					Italic = atoi(szValue);
				}
				else if (strcmp(szVar, "DirectionOfGradation") == 0) {
					DirectionOfGradation = atoi(szValue);
				}
				else if (strcmp(szVar, "Color") == 0) {
					Color = atoi(szValue);
				}
				else if (strcmp(szVar, "Color2") == 0) {
					Color2 = atoi(szValue);
				}
				else if (strcmp(szVar, "EdgeColor") == 0) {
					EdgeColor = atoi(szValue);
				}
				else if (strcmp(szVar, "EdgeColor2") == 0) {
					EdgeColor2 = atoi(szValue);
				}
				else if (strcmp(szVar, "ShadowColor") == 0) {
					ShadowColor = atoi(szValue);
				}
				else if (strcmp(szVar, "ShadowColor2") == 0) {
					ShadowColor2 = atoi(szValue);
				}
				else if (strcmp(szVar, "EdgeAlpha") == 0) {
					EdgeAlpha = atoi(szValue);
				}
				else if (strcmp(szVar, "ShadowAlpha") == 0) {
					ShadowAlpha = atoi(szValue);
				}
				else if (strcmp(szVar, "FadeEffectWhenMouseMove") == 0) {
					FadeEffectWhenMouseMove = atoi(szValue);
				}
				else if (strcmp(szVar, "IconSize") == 0) {
					IconSize = atoi(szValue);
				}
				else if (strcmp(szVar, "ShowModeFileExtension") == 0) {
					ShowModeFileExtension = atoi(szValue);
				}
				else if (strcmp(szVar, "ShowOpenFolderItem") == 0) {
					ShowOpenFolderItem = atoi(szValue);
				}
				else if (strcmp(szVar, "OpenFolderItemLabel") == 0) {
					strcpy(OpenFolderItemLabel, szValue);
				}
				else if (strcmp(szVar, "RemovableDriveHasSubMenu") == 0) {
					RemovableDriveHasSubMenu = atoi(szValue);
				}
				else if (strcmp(szVar, "ShortcutFolderHasSubMenu") == 0) {
					ShortcutFolderHasSubMenu = atoi(szValue);
				}
				else if (strcmp(szVar, "LowQualityInHovering") == 0) {
					LowQualityInHovering = atoi(szValue);
				}
				else if (strcmp(szVar, "LowQualityInMagnification") == 0) {
					LowQualityInMagnification = atoi(szValue);
				}
				else if (strcmp(szVar, "MagnificationMode") == 0) {
					MagnificationMode = atoi(szValue);
				}
				else if (strcmp(szVar, "TransitionSmoothnessExpand") == 0) {
					TransitionSmoothnessExpand = atoi(szValue);
				}
				else if (strcmp(szVar, "TransitionSmoothnessReduce") == 0) {
					TransitionSmoothnessReduce = atoi(szValue);
				}
			}
		}
		fclose(filePointer);
		loadedConfig = true;
	}
	return;
}

bool YzConfig::configIsLoaded() {
	return loadedConfig;
}

char* YzConfig::getYzDockDirectory(void) {
	return YzDockDirectory;
}

void YzConfig::setYzDockDirectory(char* directory) {
	strcpy(YzDockDirectory, directory);
}

char* YzConfig::getLanguageFile() {
	return LanguageFile;
}

void YzConfig::setLanguageFile(char* langFile) {
	strcpy(LanguageFile, langFile);
}

int YzConfig::getSmallSize() {
	return SmallSize;
}

void YzConfig::setSmallSize(int size) {
	if (size < 16) {
		SmallSize = 16;
	}
	else if (size > 192) {
		SmallSize = 192;
	}
	else {
		SmallSize = size;
	}
}

int YzConfig::getLargeSize() {
	return LargeSize;
}

void YzConfig::setLargeSize(int size) {
	if (size < 16) {
		LargeSize = 16;
	}
	else if (size > 192) {
		LargeSize = 192;
	}
	else {
		LargeSize = size;
	}
}

int YzConfig::getMagnification() {
	return Magnification;
}

void YzConfig::setMagnification(int mag) {
	if (mag < 0) {
		Magnification = 0;
	}
	else if (mag > 1) {
		Magnification = 1;
	}
	else {
		Magnification = mag;
	}
}

char* YzConfig::getIndicator() {
	return Indicator;
}

void YzConfig::setIndicator(char* ind) {
	strcpy(Indicator, ind);
}

char* YzConfig::getPoof() {
	return Poof;
}

void YzConfig::setPoof(char* inPoof) {
	strcpy(Poof, inPoof);
}

int YzConfig::getBackgroundAlpha() {
	return BackgroundAlpha;
}

void YzConfig::setBackgroundAlpha(int backAlpha) {
	if (backAlpha < 0) {
		BackgroundAlpha = 0;
	}
	else if (backAlpha > 255) {
		BackgroundAlpha = 255;
	}
	else {
		BackgroundAlpha = backAlpha;
	}
}

char* YzConfig::getBackgroundName() {
	return BackgroundName;
}

void YzConfig::setBackgroundName(char* backName) {
	strcpy(BackgroundName, backName);
}

int YzConfig::getAlwaysOnTop() {
	return AlwaysOnTop;
}

void YzConfig::setAlwaysOnTop(int onTop) {
	if (onTop < 0) {
		AlwaysOnTop = 0;
	}
	else if (onTop > 1) {
		AlwaysOnTop = 1;
	}
	else {
		AlwaysOnTop = onTop;
	}
}

int YzConfig::getAutoHide() {
	return AutoHide;
}

void YzConfig::setAutoHide(int hide) {
	if (hide < 0) {
		AutoHide = 0;
	}
	else if (hide > 1) {
		AutoHide = 1;
	}
	else {
		AutoHide = hide;
	}
}

int YzConfig::getShowSensitivity() {
	return ShowSensitivity;
}

void YzConfig::setShowSensitivity(int sensitivity) {
	if (sensitivity < 0) {
		ShowSensitivity = 0;
	}
	else if (sensitivity > 1000) {
		ShowSensitivity = 1000;
	}
	else {
		ShowSensitivity = sensitivity;
	}
}

int YzConfig::getDisappearDelayTime() {
	return DisappearDelayTime;
}

void YzConfig::setDisappearDelayTime(int delayTime) {
	if (delayTime < 0) {
		DisappearDelayTime = 0;
	}
	else if (delayTime > 10) {
		DisappearDelayTime = 10;
	}
	else {
		DisappearDelayTime = delayTime;
	}
}

int YzConfig::getOpenAppEffect() {
	return OpenAppEffect;
}

void YzConfig::setOpenAppEffect(int effect) {
	if (effect < 0) {
		OpenAppEffect = 0;
	}
	else if (effect > 1) {
		OpenAppEffect = 1;
	}
	else {
		OpenAppEffect = effect;
	}
}

int YzConfig::getOpenAppEffectExceptApp() {
	return OpenAppEffectExceptApp;
}

void YzConfig::setOpenAppEffectExceptApp(int effect) {
	if (effect < 0) {
		OpenAppEffectExceptApp = 0;
	}
	else if (effect > 1) {
		OpenAppEffectExceptApp = 1;
	}
	else {
		OpenAppEffectExceptApp = effect;
	}
}

int YzConfig::getColorOfClickedItem() {
	return ColorOfClickedItem;
}

void YzConfig::setColorOfClickedItem(int color) {
	if (color < 0) {
		ColorOfClickedItem = 0;
	}
	else if (color > 16777215) {
		ColorOfClickedItem = 16777215;
	}
	else {
		ColorOfClickedItem = color;
	}
}

int YzConfig::getNumberOfOpenAppEffect() {
	return NumberOfOpenAppEffect;
}

void YzConfig::setNumberOfOpenAppEffect(int number) {
	if (number < 1) {
		NumberOfOpenAppEffect = 1;
	}
	else if (number > 5) {
		NumberOfOpenAppEffect = 5;
	}
	else {
		NumberOfOpenAppEffect = number;
	}
}

int YzConfig::getLockedMoveDeleteItem() {
	return LockedMoveDeleteItem;
}

void YzConfig::setLockedMoveDeleteItem(int lmdItem) {
	if (lmdItem < 0) {
		LockedMoveDeleteItem = 0;
	}
	else if (lmdItem > 1) {
		LockedMoveDeleteItem = 1;
	}
	else {
		LockedMoveDeleteItem = lmdItem;
	}
}

int YzConfig::getWindowFocusBack() {
	return WindowFocusBack;
}

void YzConfig::setWindowFocusBack(int focus) {
	if (focus < 0) {
		WindowFocusBack = 0;
	}
	else if (focus > 1) {
		WindowFocusBack = 1;
	}
	else {
		WindowFocusBack = focus;
	}
}

int YzConfig::getPositionOnScreen() {
	return PositionOnScreen;
}

void YzConfig::setPositionOnScreen(int position) {
	if (position < 0) {
		PositionOnScreen = 0;
	}
	else if (position > 3) {
		PositionOnScreen = 3;
	}
	else {
		PositionOnScreen = position;
	}
}

int YzConfig::getPositionOnScreen2() {
	return PositionOnScreen2;
}

void YzConfig::setPositionOnScreen2(int position) {
	if (position < 0) {
		PositionOnScreen2 = 0;
	}
	else if (position > 2) {
		PositionOnScreen2 = 2;
	}
	else {
		PositionOnScreen2 = position;
	}
}

int YzConfig::getPositionMargin() {
	return PositionMargin;
}

void YzConfig::setPositionMargin(int margin) {
	if (margin < 0) {
		PositionMargin = 0;
	}
	else if (margin > 400) {
		PositionMargin = 400;
	}
	else {
		PositionMargin = margin;
	}
}

int YzConfig::getMultiMonitorSupport() {
	return MultiMonitorSupport;
}

void YzConfig::setMultiMonitorSupport(int multiMon) {
	if (multiMon < 0) {
		MultiMonitorSupport = 0;
	}
	else if (multiMon > 1) {
		MultiMonitorSupport = 1;
	}
	else {
		MultiMonitorSupport = multiMon;
	}
}

char* YzConfig::getFont() {
	return Font;
}

void YzConfig::setFont(char* inFont) {
	strcpy(Font, inFont);
}

int YzConfig::getFontSize() {
	return FontSize;
}

void YzConfig::setFontSize(int size) {
	if (size < 7) {
		FontSize = 7;
	}
	else if (size > 72) {
		FontSize = 72;
	}
	else {
		FontSize = size;
	}
}

int YzConfig::getBold() {
	return Bold;
}

void YzConfig::setBold(int inBold) {
	if (inBold < 0) {
		Bold = 0;
	}
	else if (inBold > 1) {
		Bold = 1;
	}
	else {
		Bold = inBold;
	}
}

int YzConfig::getItalic() {
	return Italic;
}

void YzConfig::setItalic(int inItalic) {
	if (inItalic < 0) {
		Italic = 0;
	}
	else if (inItalic > 1) {
		Italic = 1;
	}
	else {
		Italic = inItalic;
	}
}

int YzConfig::getDirectionOfGradation() {
	return DirectionOfGradation;
}

void YzConfig::setDirectionOfGradation(int direction) {
	if (direction < 0) {
		DirectionOfGradation = 0;
	}
	else if (direction > 1) {
		DirectionOfGradation = 1;
	}
	else {
		DirectionOfGradation = direction;
	}
}

int YzConfig::getColor() {
	return Color;
}

void YzConfig::setColor(int col) {
	if (col < 0) {
		Color = 0;
	}
	else if (col > 16777215) {
		Color = 16777215;
	}
	else {
		Color = col;
	}
}

int YzConfig::getColor2() {
	return Color2;
}

void YzConfig::setColor2(int col) {
	if (col < 0) {
		Color2 = 0;
	}
	else if (col > 16777215) {
		Color2 = 16777215;
	}
	else {
		Color2 = col;
	}
}

int YzConfig::getEdgeColor() {
	return EdgeColor;
}

void YzConfig::setEdgeColor(int color) {
	if (color < 0) {
		EdgeColor = 0;
	}
	else if (color > 16777215) {
		EdgeColor = 16777215;
	}
	else {
		EdgeColor = color;
	}
}

int YzConfig::getEdgeColor2() {
	return EdgeColor;
}

void YzConfig::setEdgeColor2(int color) {
	if (color < 0) {
		EdgeColor2 = 0;
	}
	else if (color > 16777215) {
		EdgeColor2 = 16777215;
	}
	else {
		EdgeColor2 = color;
	}
}

int YzConfig::getShadowColor() {
	return ShadowColor;
}

void YzConfig::setShadowColor(int color) {
	if (color < 0) {
		ShadowColor = 0;
	}
	else if (color > 16777215) {
		ShadowColor = 16777215;
	}
	else {
		ShadowColor = color;
	}
}

int YzConfig::getShadowColor2() {
	return ShadowColor2;
}

void YzConfig::setShadowColor2(int color) {
	if (color < 0) {
		ShadowColor2 = 0;
	}
	else if (color > 16777215) {
		ShadowColor2 = 16777215;
	}
	else {
		ShadowColor2 = color;
	}
}

int YzConfig::getEdgeAlpha() {
	return EdgeAlpha;
}

void YzConfig::setEdgeAlpha(int alpha) {
	if (alpha < 0) {
		EdgeAlpha = 0;
	}
	else if (alpha > 255) {
		EdgeAlpha = 255;
	}
	else {
		EdgeAlpha = alpha;
	}
}

int YzConfig::getShadowAlpha() {
	return ShadowAlpha;
}

void YzConfig::setShadowAlpha(int alpha) {
	if (alpha < 0) {
		ShadowAlpha = 0;
	}
	else if (alpha > 255) {
		ShadowAlpha = 255;
	}
	else {
		ShadowAlpha = alpha;
	}
}

int YzConfig::getFadeEffectWhenMouseMove() {
	return FadeEffectWhenMouseMove;
}

void YzConfig::setFadeEffectWhenMouseMove(int effect) {
	if (effect < 0) {
		FadeEffectWhenMouseMove = 0;
	}
	else if (effect > 1) {
		FadeEffectWhenMouseMove = 1;
	}
	else {
		FadeEffectWhenMouseMove = effect;
	}
}

int YzConfig::getIconSize() {
	return IconSize;
}

void YzConfig::setIconSize(int size) {
	if (size < 1) {
		IconSize = 1;
	}
	else if (size > 3) {
		IconSize = 3;
	}
	else {
		IconSize = size;
	}
}

int YzConfig::getShowModeFileExtension() {
	return ShowModeFileExtension;
}

void YzConfig::setShowModeFileExtension(int showMode) {
	if (showMode < 0) {
		ShowModeFileExtension = 0;
	}
	else if (showMode > 2) {
		ShowModeFileExtension = 2;
	}
	else {
		ShowModeFileExtension = showMode;
	}
}

int YzConfig::getShowOpenFolderItem() {
	return ShowOpenFolderItem;
}

void YzConfig::setShowOpenFolderItem(int showOpen) {
	if (showOpen < 0) {
		ShowOpenFolderItem = 0;
	}
	else if (showOpen > 1) {
		ShowOpenFolderItem = 1;
	}
	else {
		ShowOpenFolderItem = showOpen;
	}
}

char* YzConfig::getOpenFolderItemLabel() {
	return OpenFolderItemLabel;
}

void YzConfig::setOpenFolderItemLabel(char* label) {
	strcpy(OpenFolderItemLabel, label);
}

int YzConfig::getRemovableDriveHasSubMenu() {
	return RemovableDriveHasSubMenu;
}

void YzConfig::setRemovableDriveHasSubMenu(int hasSubMenu) {
	if (hasSubMenu < 0) {
		RemovableDriveHasSubMenu = 0;
	}
	else if (hasSubMenu > 1) {
		RemovableDriveHasSubMenu = 1;
	}
	else {
		RemovableDriveHasSubMenu = hasSubMenu;
	}
}

int YzConfig::getShortcutFolderHasSubMenu() {
	return ShortcutFolderHasSubMenu;
}

void YzConfig::setShortcutFolderHasSubMenu(int hasSubMenu) {
	if (hasSubMenu < 0) {
		ShortcutFolderHasSubMenu = 0;
	}
	else if (hasSubMenu > 1) {
		ShortcutFolderHasSubMenu = 1;
	}
	else {
		ShortcutFolderHasSubMenu = hasSubMenu;
	}
}

int YzConfig::getLowQualityInHovering() {
	return LowQualityInHovering;
}

void YzConfig::setLowQualityInHovering(int quality) {
	if (quality < 0) {
		LowQualityInHovering = 0;
	}
	else if (quality > 1) {
		LowQualityInHovering = 1;
	}
	else {
		LowQualityInHovering = quality;
	}
}

int YzConfig::getLowQualityInMagnification() {
	return LowQualityInMagnification;
}

void YzConfig::setLowQualityInMagnification(int quality) {
	if (quality < 0) {
		LowQualityInMagnification = 0;
	}
	else if (quality > 1) {
		LowQualityInMagnification = 1;
	}
	else {
		LowQualityInMagnification = quality;
	}
}

int YzConfig::getMagnificationMode() {
	return MagnificationMode;
}

void YzConfig::setMagnificationMode(int magMode) {
	if (magMode < 0) {
		MagnificationMode = 0;
	}
	else if (magMode > 1) {
		MagnificationMode = 1;
	}
	else {
		MagnificationMode = magMode;
	}
}

int YzConfig::getTransitionSmoothnessExpand() {
	return TransitionSmoothnessExpand;
}

void YzConfig::setTransitionSmoothnessExpand(int smoothness) {
	if (smoothness < 10) {
		TransitionSmoothnessExpand = 10;
	}
	else if (smoothness > 160) {
		TransitionSmoothnessExpand = 160;
	}
	else {
		TransitionSmoothnessExpand = smoothness;
	}
}

int YzConfig::getTransitionSmoothnessReduce() {
	return TransitionSmoothnessReduce;
}

void YzConfig::setTransitionSmoothnessReduce(int smoothness) {
	if (smoothness < 10) {
		TransitionSmoothnessReduce= 10;
	}
	else if (smoothness > 160) {
		TransitionSmoothnessReduce = 160;
	}
	else {
		TransitionSmoothnessReduce = smoothness;
	}
}
