#include <windows.h>

class YzConfig {
// variables
public:

private:
	bool loadedConfig;
	char YzDockDirectory[256];
	// Start of Y'z Dock config
	char LanguageFile[256];
	int SmallSize;
	int LargeSize;
	int Magnification;
	char Indicator[256];
	char Poof[256];
	int BackgroundAlpha;
	char BackgroundName[256];
	int AlwaysOnTop;
	int AutoHide;
	int ShowSensitivity;
	int DisappearDelayTime;
	int OpenAppEffect;
	int OpenAppEffectExceptApp;
	int ColorOfClickedItem;
	int NumberOfOpenAppEffect;
	int LockedMoveDeleteItem;
	int WindowFocusBack;
	int PositionOnScreen;
	int PositionOnScreen2;
	int PositionMargin;
	int MultiMonitorSupport;
	char Font[256];
	int FontSize;
	int Bold;
	int Italic;
	int DirectionOfGradation;
	int Color;
	int Color2;
	int EdgeColor;
	int EdgeColor2;
	int ShadowColor;
	int ShadowColor2;
	int EdgeAlpha;
	int ShadowAlpha;
	int FadeEffectWhenMouseMove;
	int IconSize;
	int ShowModeFileExtension;
	int ShowOpenFolderItem;
	char OpenFolderItemLabel[256];
	int RemovableDriveHasSubMenu;
	int ShortcutFolderHasSubMenu;
	int LowQualityInHovering;
	int	LowQualityInMagnification;
	int	MagnificationMode;
	int	TransitionSmoothnessExpand;
	int	TransitionSmoothnessReduce;
	// End of Y'z Dock config
// methods
public:
	YzConfig() {
		loadedConfig = false;
		//YzDockDirectory = ".none";
		strcpy(YzDockDirectory, ".none");
		// set up default Y'z Dock config values
		strcpy(LanguageFile, "English.lang");
		SmallSize = 48;
		LargeSize = 128;
		Magnification = 1;
		strcpy(Indicator, "Default");
		strcpy(Poof, "Default");
		BackgroundAlpha = 180;
		strcpy(BackgroundName, "Default");
		AlwaysOnTop = 1;
		AutoHide = 0;
		ShowSensitivity = 0;
		DisappearDelayTime = 0;
		OpenAppEffect = 1;
		OpenAppEffectExceptApp = 0;
		ColorOfClickedItem = 8355711;
		NumberOfOpenAppEffect = 2;
		LockedMoveDeleteItem = 0;
		WindowFocusBack = 0;
		PositionOnScreen = 0;
		PositionOnScreen2 = 0;
		PositionMargin = 0;
		MultiMonitorSupport = 0;
		strcpy(Font, "Tahoma");
		FontSize = 13;
		Bold = 1;
		Italic = 0;
		DirectionOfGradation = 0;
		Color = 16777215;
		Color2 = 16697014;
		EdgeColor = 0;
		EdgeColor2 = 16711680;
		ShadowColor = 0;
		ShadowColor2 = 5395026;
		EdgeAlpha = 50;
		ShadowAlpha = 180;
		FadeEffectWhenMouseMove = 0;
		IconSize = 1;
		ShowModeFileExtension = 1;
		ShowOpenFolderItem = 1;
		strcpy(OpenFolderItemLabel, "Show in Explorer");
		RemovableDriveHasSubMenu = 1;
		ShortcutFolderHasSubMenu = 1;
		LowQualityInHovering = 0;
		LowQualityInMagnification = 0;
		MagnificationMode = 1;
		TransitionSmoothnessExpand = 35;
		TransitionSmoothnessReduce = 35;
	}
	void writeConfigFile(void);
	void readConfigFile(void);
	bool configIsLoaded(void);
	char* getYzDockDirectory(void);
	void setYzDockDirectory(char* directory);
	char* getLanguageFile(void);
	void setLanguageFile(char* langFile);
	int getSmallSize(void);
	void setSmallSize(int size);
	int getLargeSize(void);
	void setLargeSize(int size);
	int getMagnification(void);
	void setMagnification(int mag);
	char* getIndicator(void);
	void setIndicator(char* ind);
	char* getPoof(void);
	void setPoof(char* inPoof);
	int getBackgroundAlpha(void);
	void setBackgroundAlpha(int backAlpha);
	char* getBackgroundName(void);
	void setBackgroundName(char* backName);
	int getAlwaysOnTop(void);
	void setAlwaysOnTop(int onTop);
	int getAutoHide(void);
	void setAutoHide(int hide);
	int getShowSensitivity(void);
	void setShowSensitivity(int sensitivity);
	int getDisappearDelayTime(void);
	void setDisappearDelayTime(int delayTime);
	int getOpenAppEffect(void);
	void setOpenAppEffect(int effect);
	int getOpenAppEffectExceptApp(void);
	void setOpenAppEffectExceptApp(int effect);
	int getColorOfClickedItem(void);
	void setColorOfClickedItem(int color);
	int getNumberOfOpenAppEffect(void);
	void setNumberOfOpenAppEffect(int number);
	int getLockedMoveDeleteItem(void);
	void setLockedMoveDeleteItem(int lmdItem);
	int getWindowFocusBack(void);
	void setWindowFocusBack(int focus);
	int getPositionOnScreen(void);
	void setPositionOnScreen(int position);
	int getPositionOnScreen2(void);
	void setPositionOnScreen2(int position);
	int getPositionMargin(void);
	void setPositionMargin(int margin);
	int getMultiMonitorSupport(void);
	void setMultiMonitorSupport(int multiMon);
	char* getFont(void);
	void setFont(char* inFont);
	int getFontSize(void);
	void setFontSize(int size);
	int getBold(void);
	void setBold(int inBold);
	int getItalic(void);
	void setItalic(int inItalic);
	int getDirectionOfGradation(void);
	void setDirectionOfGradation(int direction);
	int getColor(void);
	void setColor(int col);
	int getColor2(void);
	void setColor2(int col);
	int getEdgeColor(void);
	void setEdgeColor(int color);
	int getEdgeColor2(void);
	void setEdgeColor2(int color);
	int getShadowColor(void);
	void setShadowColor(int color);
	int getShadowColor2(void);
	void setShadowColor2(int color);
	int getEdgeAlpha(void);
	void setEdgeAlpha(int alpha);
	int getShadowAlpha(void);
	void setShadowAlpha(int alpha);
	int getFadeEffectWhenMouseMove(void);
	void setFadeEffectWhenMouseMove(int effect);
	int getIconSize(void);
	void setIconSize(int size);
	int getShowModeFileExtension(void);
	void setShowModeFileExtension(int showMode);
	int getShowOpenFolderItem(void);
	void setShowOpenFolderItem(int showOpen);
	char* getOpenFolderItemLabel(void);
	void setOpenFolderItemLabel(char* label);
	int getRemovableDriveHasSubMenu(void);
	void setRemovableDriveHasSubMenu(int hasSubMenu);
	int getShortcutFolderHasSubMenu(void);
	void setShortcutFolderHasSubMenu(int hasSubMenu);
	int getLowQualityInHovering(void);
	void setLowQualityInHovering(int quality);
	int getLowQualityInMagnification(void);
	void setLowQualityInMagnification(int quality);
	int getMagnificationMode(void);
	void setMagnificationMode(int magMode);
	int getTransitionSmoothnessExpand(void);
	void setTransitionSmoothnessExpand(int smoothness);
	int getTransitionSmoothnessReduce(void);
	void setTransitionSmoothnessReduce(int smoothness);
private:
};